diff -urN ./xl2tpd/control.c ./xl2tpd.patched/control.c
--- ./xl2tpd/control.c	2013-08-11 21:25:21.949287131 +0200
+++ ./xl2tpd.patched/control.c	2013-08-11 19:41:12.298130410 +0200
@@ -158,6 +158,12 @@
     udp_xmit (buf, t);
 }
 
+void add_my_ip(struct tunnel *t, struct ppp_opts *po)
+{
+    add_opt (po, "myip");
+    add_opt (po, "%s", IPADDY (t->my_addr.ipi_spec_dst));
+}
+
 int control_finish (struct tunnel *t, struct call *c)
 {
     /*
@@ -915,6 +921,7 @@
             po = add_opt (po, "ipparam");
             po = add_opt (po, IPADDY (t->peer.sin_addr));
         }
+	add_my_ip(t, po);
         start_pppd (c, po);
         opt_destroy (po);
         if (c->lac)
@@ -994,6 +1001,7 @@
             po = add_opt (po, "ipparam");
             po = add_opt (po, IPADDY (t->peer.sin_addr));
         }
+	add_my_ip(t, po);
         start_pppd (c, po);
         opt_destroy (po);
         l2tp_log (LOG_NOTICE,
@@ -1057,6 +1065,7 @@
             po = add_opt (po, "ipparam");
             po = add_opt (po, IPADDY (t->peer.sin_addr));
         }
+	add_my_ip(t, po);
         start_pppd (c, po);
 
         /*  jz: just show some information */
diff -urN ./xl2tpd/file.h ./xl2tpd.patched/file.h
--- ./xl2tpd/file.h	2013-08-11 21:25:21.958286139 +0200
+++ ./xl2tpd.patched/file.h	2013-08-12 12:39:05.378460982 +0200
@@ -50,14 +50,14 @@
 #define SENSE_DENY 0
 
 #ifndef DEFAULT_AUTH_FILE
-#define DEFAULT_AUTH_FILE "/etc/xl2tpd/l2tp-secrets"
+#define DEFAULT_AUTH_FILE "/opt/xl2tpd/etc/l2tp-secrets"
 #endif
 #ifndef DEFAULT_CONFIG_FILE
-#define DEFAULT_CONFIG_FILE "/etc/xl2tpd/xl2tpd.conf"
+#define DEFAULT_CONFIG_FILE "/opt/xl2tpd/etc/xl2tpd.conf"
 #endif
-#define ALT_DEFAULT_AUTH_FILE "/etc/l2tpd/l2tp-secrets"
-#define ALT_DEFAULT_CONFIG_FILE "/etc/l2tp/l2tpd.conf"
-#define DEFAULT_PID_FILE "/var/run/xl2tpd.pid"
+#define ALT_DEFAULT_AUTH_FILE "/opt/l2tpd/etc/l2tp-secrets"
+#define ALT_DEFAULT_CONFIG_FILE "/opt/l2tp/etc/l2tpd.conf"
+#define DEFAULT_PID_FILE "/opt/l2tpd/var/run/xl2tpd.pid"
 
 /* Definition of an LNS */
 struct lns
diff -urN ./xl2tpd/l2tp.h ./xl2tpd.patched/l2tp.h
--- ./xl2tpd/l2tp.h	2013-08-11 21:25:21.958286139 +0200
+++ ./xl2tpd.patched/l2tp.h	2013-08-12 13:07:11.161125480 +0200
@@ -37,7 +37,7 @@
 #include "common.h"
 #include "ipsecmast.h"
 
-#define CONTROL_PIPE "/var/run/xl2tpd/l2tp-control"
+#define CONTROL_PIPE "/opt/xl2tpd/var/run/l2tp-control"
 #define CONTROL_PIPE_MESSAGE_SIZE 1024
 
 #define BINARY "xl2tpd"
diff -urN ./xl2tpd/Makefile ./xl2tpd.patched/Makefile
--- ./xl2tpd/Makefile	2013-08-11 21:25:21.947287351 +0200
+++ ./xl2tpd.patched/Makefile	2013-08-12 12:43:13.810805358 +0200
@@ -47,7 +47,7 @@
 # trust pppd. This work around will be removed in the near future.
 
 # DFLAGS= -g -DDEBUG_HELLO -DDEBUG_CLOSE -DDEBUG_FLOW -DDEBUG_PAYLOAD -DDEBUG_CONTROL -DDEBUG_CONTROL_XMIT -DDEBUG_FLOW_MORE -DDEBUG_MAGIC -DDEBUG_ENTROPY -DDEBUG_HIDDEN -DDEBUG_PPPD -DDEBUG_AAA -DDEBUG_FILE -DDEBUG_FLOW -DDEBUG_HELLO -DDEBUG_CLOSE -DDEBUG_ZLB -DDEBUG_AUTH
-DFLAGS?= -DDEBUG_PPPD -DTRUST_PPPD_TO_DIE
+DFLAGS= -g -DDEBUG_PPPD -DTRUST_PPPD_TO_DIE
 
 # Uncomment the next line for Linux. KERNELSRC is needed for if_pppol2tp.h,
 # but we use a local copy if we don't find it.
@@ -100,11 +100,15 @@
 EXEC=xl2tpd
 CONTROL_EXEC=xl2tpd-control
 
-PREFIX?=/usr/local
+PREFIX?=/opt/xl2tpd
 SBINDIR?=$(DESTDIR)${PREFIX}/sbin
 BINDIR?=$(DESTDIR)${PREFIX}/bin
 MANDIR?=$(DESTDIR)${PREFIX}/share/man
 
+CONFDIR?=$(DESTDIR)${PREFIX}/etc
+VARDIR?=$(DESTDIR)${PREFIX}/var
+VAR2DIR?=/var/l2tp/
+RUNDIR?=$(VARDIR)/run
 
 all: $(EXEC) pfc $(CONTROL_EXEC)
 
@@ -126,6 +130,10 @@
 
 install: ${EXEC} pfc ${CONTROL_EXEC}
 	install -d -m 0755 ${SBINDIR}
+	install -d -m 0755 ${CONFDIR}
+	install -d -m 0755 ${VARDIR}
+	install -d -m 0755 ${VAR2DIR}
+	install -d -m 0755 ${RUNDIR}
 	install -m 0755 $(EXEC) ${SBINDIR}/$(EXEC)
 	install -d -m 0755 ${MANDIR}/man5
 	install -d -m 0755 ${MANDIR}/man8
